10 REM             Spurious response prediction program 
11 REM after S J Erst, "Receiving System Design" (Artech House, 1984), 120-123.
12 REM          This MBASIC version (c) 1985 by Ian White, G3SEK.
13 REM      Program structure is totally changed, and major variables now
14 REM      have meaningful names; names of minor variables are unchanged.
15 :
50 DIM W(7,8)
60 DEF FNR(X)=INT(X*10+.5)/10
70 GOSUB 5000
99 :
100 GOSUB 1000: REM print heading
110 GOSUB 1100: REM print definitions
120 GOSUB 2000: REM fill menu
130 GOSUB 3000: REM calculate & print results
140 PRINT"Press RETURN for new/repeat run, ^C to quit.":INPUT"",T$:GOTO 120
999 :
1000 FIRST=-1:PRINT:PRINT TAB(8);"SPURIOUS RESPONSE PREDICTION FOR SUPERHETERODYNE RECEIVERS"
1010 PRINT:PRINT:RETURN
1099 :
1100 PRINT"Calculates frequencies giving spurious responses up to 15th order"
1110 PRINT"and estimates suppression below wanted signal level,"
1120 PRINT"using the following assumptions."
1130 PRINT"1. Class 2 balanced mixer with signal level -10dBm, lo level +17dBm."
1140 PRINT"2. Optional lower level below which spurious responses are not reported."
1150 PRINT"3. Optional lowpass filtering with definable performance."
1160 PRINT"4. Optional bandpass filtering with definable performance."
1170 PRINT:PRINT
1180 RETURN
1999 :
2000 PRINT:PRINT TAB(10);"MAIN MENU"
2010 PRINT
2020 PRINT:PRINT"Fmin and Fmax are limits of signal frequency Fsig":GOSUB 2300
2030 INPUT "Fmin : ",T$:IF T$<>"" THEN FMIN=VAL(T$):IF FMIN<=0 GOTO 2030
2040 INPUT "Fmax : ",T$:IF T$<>"" THEN FMAX=VAL(T$):IF FMAX<=0 GOTO 2040
2050 FSIG=FMIN:PRINT"Program will scan Fmin to Fmax in steps of Fstep."
2060 INPUT "Fstep: ",T$:IF T$<>"" THEN FSTEP=VAL(T$):IF FSTEP<=0 GOTO 2060
2070 PRINT:INPUT "Fif  : ",T$:IF T$<>"" THEN FIF=VAL(T$):IF FIF<=0 GOTO 2070
2080 PRINT:PRINT"Choose mixing scheme.":GOSUB 2300
2090 PRINT TAB(10);"1   Fif = Flo - Fsig"
2100 PRINT TAB(10);"2   Fif = Fsig - Flo"
2110 PRINT TAB(10);"3   Fif = Fsig + Flo"
2120 INPUT "Option No. : ",T$:IF T$<>"" THEN OPT=INT(VAL(T$))
2130 IF OPT<=0 OR OPT>3 GOTO 2120
2140 PRINT:INPUT "Set minimum reporting level (Y/N) ? ",T$:IF T$<>"Y" AND T$<>"N" GOTO 2140
2150 IF T$="Y" THEN GOSUB 2500 ELSE A1=200
2160 PRINT:INPUT "Assume lowpass filtering (Y/N) ? ",T$:IF T$<>"Y" AND T$<>"N" GOTO 2160
2170 IF T$="Y" THEN GOSUB 2600 ELSE LPF=0: SL=0
2180 PRINT:INPUT "Assume bandpass filtering (Y/N) ? ",T$:IF T$<>"Y" AND T$<>"N" GOTO 2180
2190 IF T$="Y" THEN GOSUB 2700 ELSE BPF=0: SB=0
2200 FIRST=0:RETURN
2299 :
2300 IF NOT FIRST THEN PRINT"(Press RETURN to re-use data from previous calculation)"
2310 RETURN
2499 :
2500 PRINT"Reference signal level = -10dBm"
2510 PRINT"Enter suppression (dB) below which spurious responses are not reported"
2520 INPUT": ",A1:A1=ABS(A1)
2530 RETURN
2599 :
2600 REM get lpf parameters
2610 IF LPF AND NOT FIRST THEN INPUT"Is lowpass filter exactly as before (Y/N)? : ",T$:IF T$="Y" THEN RETURN
2620 IF LPF AND NOT FIRST THEN GOSUB 2300
2630 LPF=-1:INPUT"Lpf cutoff : ",T$:IF T$<>"" THEN B2=VAL(T$):IF B2<=FMAX GOTO 2630
2640 INPUT"Order of lpf : ",T$:IF T$<>"" THEN C2=INT(VAL(T$)):IF C2<1 GOTO 2640
2650 INPUT"Ripple (dB) : ",T$:IF T$<>"" THEN D2=VAL(T$):IF C2<0 GOTO 2650
2660 INPUT"Ultimate atten (dB) : ",T$:IF T$<>"" THEN E2=VAL(T$):IF E2<0 GOTO 2660
2670 RETURN
2699 :
2700 REM get bpf parameters
2710 IF BPF AND NOT FIRST THEN INPUT"Is bandpass filter exactly as before (Y/N)? : ",T$:IF T$="Y" THEN RETURN
2720 IF BPF AND NOT FIRST THEN GOSUB 2300
2730 BPF=-1:INPUT"Is bpf fixed (F) or tuned to Fsig (T)? : ",T$:IF T$<>"" AND T$<>"F" AND T$<>"T" GOTO 2730
2740 IF T$="F" THEN FIXB=-1:IF FIXB GOTO 2800
2750 PRINT"Assumes critically coupled bpf."
2760 INPUT"Order of bpf : ",T$:IF T$<>"" THEN N1=INT(VAL(T$)):IF N1<1 GOTO 2760
2770 INPUT"Loaded Q of each resonator : ",T$:IF T$<>"" THEN Q1=VAL(T$):IF Q1<1 GOTO 2770
2780 INPUT"Ultimate atten (dB) : ",T$:IF T$<>"" THEN R2=VAL(T$):IF R2<0 GOTO 2780
2790 RETURN
2800 PRINT"Assumes fixed-tuned Chebyshev filter."
2810 INPUT"Order of bpf : ",T$:IF T$<>"" THEN N1=INT(VAL(T$)):IF N1<1 GOTO 2810
2820 INPUT"Fmin : ",T$:IF T$<>"" THEN A3=VAL(T$):IF A3>FMAX GOTO 2820
2830 INPUT"Fmax : ",T$:IF T$<>"" THEN A2=VAL(T$):IF A2<FMIN GOTO 2830
2840 INPUT"Ripple (dB) : ",T$:IF T$<>"" THEN R1=VAL(T$):IF R1<0 GOTO 2840
2850 INPUT"Ultimate atten (dB) : ",T$:IF T$<>"" THEN R2=VAL(T$):IF R2<0 GOTO 2850
2860 RETURN
2999 :
3000 PRINT:PRINT:PRINT TAB(10);"Receiver responds to Fspu when:  Fif = M * Flo + N * Fspu"
3010 PRINT TAB(5);"where M, N are integers of either sign; |M| = 0 to 8, |N| = 1 to 7":PRINT
3020 PRINT"       Frequencies        Orders        Suppression (dB below a -10dBm signal)"
3030 PRINT"sig     lo      spu      M     N         mixer       filters      total":PRINT
3100 FOR FSIG=FMIN TO FMAX STEP FSTEP
3110 FOR ORDER=1 TO 15
3120 FOR N=1 TO ORDER
3130 FOR K=1 TO 3 STEP 2: IF K=3 AND ORDER=N GOTO 3210
3140 IF N>7 GOTO 3210 ELSE M=(2-K)*(ORDER-N):M1=ABS(M):IF M1>8 GOTO 3210
3150 GOSUB 3300:FSPU=ABS(FIF + M*L)/N
3160 Q=W(N,M1)
3170 IF Q>A1 GOTO 3210
3180 IF LPF THEN GOSUB 4000: Q=Q + SL: IF Q>A1 GOTO 3210
3190 IF BPF THEN GOSUB 4500: Q=Q + SB: IF Q>A1 GOTO 3210
3200 PRINT TAB(1);FNR(FSIG);TAB(7);FNR(L);TAB(15);FNR(FSPU);TAB(25);M;TAB(31);N;TAB(41);W(N,M1);TAB(54);FNR(SL+SB);TAB(67);FNR(Q)
3210 NEXT K
3220 NEXT N
3230 NEXT ORDER
3240 PRINT
3250 NEXT FSIG
3260 RETURN
3299 :
3300 IF OPT=1 THEN L=FIF+FSIG:RETURN
3310 IF OPT=2 THEN L=FSIG-FIF:RETURN
3320 L=FIF-FSIG:RETURN
3999 :
4000 REM   Estimate lpf suppression SL
4010 IF FSPU<B2 THEN SL=0:RETURN ELSE F2=ABS((B2*.00001/FSPU-FSPU)/B2)
4020 G2=C2*LOG(F2+SQR(F2*F2-1))
4030 H2=EXP(G2):H2=(H2 + 1/H2)/2
4040 I2=10^(D2/10)-1
4050 SL=4.34295*LOG(1+I2*H2*H2*F2)
4060 IF SL>E2 THEN SL=E2
4070 RETURN
4499 :
4500 REM    Estimate bpf suppression SB
4510 IF FIXB GOTO 4540
4520 SB=(2*Q1*(FSIG-FSPU)/FSIG):SB=(SB^4)/4:SB=8.68589*LOG((1 + SB/2)^(N1/2))
4530 GOTO 4600
4540 IF FSPU>A3 AND FSPU<A2 THEN SB=0:RETURN: REM Fspu in passband
4550 X2=ABS((FMIN*FMAX/FSPU - FSPU)/(FMAX-FMIN))
4560 C1=N1*LOG(X2+SQR(X2*X2-1)):C1=EXP(C1)
4570 C1=(C1+1/C1)/2
4580 R=10^(R1/10)-1
4590 SB=4.34295*LOG(1+R*C1*C1*X2)
4600 IF SB>R2 THEN SB=R2
4610 RETURN
4999 :
5000 FOR J=0 TO 3: REM read in mixer spurious suppression data
5010 FOR K=0 TO 8:READ W(J,K):NEXT
5020 NEXT
5030 FOR J=4 TO 7:FOR K=0 TO 8:W(J,K)=90:NEXT
5040 NEXT
5050 RESTORE
5060 DATA 0,27,31,36,47,36,51,37,63
5070 DATA 23,0,39,11,46,14,62,19,53
5080 DATA 86,75,84,75,86,74,87,74,84
5090 DATA 87,77,87,78,90,75,85,77,88
5100 RETURN
