10 REM    TCALC4, a program for calculating cumulative noise figures, 
11 REM           noise temperatures, gains and intermodulation intercepts
12 REM		 of cascaded stages in receiver systems.
13 REM
14 REM   (c) July 1984 by Ian White, G3SEK.
15 REM
16 REM    Microsoft BASIC verion for 80-column screen.
17 REM    This version is written for clarity and ease of translation 
18 REM    to other BASIC dialects, rather than for compactness.
19 REM
20 DIM TYPE(10): REM 1=first stage, 2=AMPlifier, 3=MIXer, 4=CABle, 5=ATTenuator, 6=ANTenna, 7=END
30 REM If a DIM declaration in your BASIC doesn't zero the array TYPE(), do it here.
40 DIM NT(10): REM stage noise temperature (K)
50 DIM GAIN(10): REM stage gain (ratio)
60 DEF FNA(X) = EXP(X * .230259): REM reverse dB
70 DEF FNB(X) = 4.34294 * LOG(X): REM dB from natural log
80 DEF FNC(X) = .1 * INT(10 * X + .5)
90 DEF FND(X) = .01 * INT(100 * X + .5)
100 PRINT: PRINT: PRINT "TCALC by G3SEK": PRINT: PRINT
110 PRINT "Stages are numbered backwards towards antenna": PRINT: GOSUB 2300
120 FIRST = 1: ID = 0: GOTO 250
199 REM  200 is return point after calc completed
200 FOR I = 1 TO 78: PRINT; "-";:NEXT I: PRINT
210 INPUT "Repeat, intermod analysis of existing system, or quit?    (R/I/Q): ", R$
220 IF R$ <> "R" AND R$ <> "I" THEN END
230 FIRST = 0: IF R$ = "I" THEN ID=1: GOTO 2000: REM go calculate intermods
240 PRINT: PRINT: PRINT "Hit [RETURN] to recall old data": PRINT
250 GOSUB 2400: M = 1: T = 0: G = 1: TYPE(1) = 1: REM heading and initialization
260 PRINT "Stage 1 (rest of system)": IF FIRST = 1 GOTO 1300
270 PRINT "N for new data,": INPUT "[RETURN] for old: " ,T$: IF T$ = "" GOTO 1700
280 GOTO 1300
298 :
299 REM 300 is return point for more/new data
300 M = M + 1
310 IF M > 10 THEN  PRINT "TOO MANY STAGES": GOTO 200
999 REM read in data
1000 PRINT "Stage ";M;" Type: ";: INPUT"", A$: A$ = LEFT$(A$,3)
1010 IF A$ = "AMP" THEN TYPE(M) = 2: GOTO 1300
1020 IF A$ = "MIX" THEN TYPE(M) = 3: GOTO 1300
1030 IF A$ = "CAB" THEN TYPE(M) = 4: GOTO 1400
1040 IF A$ = "ATT" THEN TYPE(M) = 5: GOTO 1400
1050 IF A$ = "ANT" THEN TYPE(M) = 6: GOTO 1500
1060 IF A$ = "END" THEN TYPE(M) = 7: GOTO 1500
1070 IF A$ = "" THEN GOTO 1700
1080 PRINT A$;"???", CHR$(7): GOSUB 2300: GOTO 1000
1299 :
1300 INPUT "T(>20K) or NF(<20dB): ", R: REM first stage, AMP or MIX input
1310 IF R > = 20 GOTO 1330
1320 R = 290 * (FNA(R) - 1)
1330 NT(M) = R
1340 IF M = 1 THEN  G2 = 1: GOTO 1360
1350 INPUT "Gain (dB): ", G2: G2 = FNA(G2)
1360 GAIN(M) = G2
1370 GOSUB 3000: GOTO 1800
1399 :
1400 INPUT "Loss (dB): ", L: REM  CABle/ATTenuator input
1410 L = ABS (L): L = FNA(L)
1420 NT(M) = 0: GAIN(M) = 1/L
1430 GOSUB 3100: GOTO 1800
1499 :
1500 GAIN(M) = 1: REM  ANT input or END
1510 IF TYPE(M) = 7 THEN NT(M) = 0: GOTO 200: REM END
1520 INPUT "Ant. noise temp (K): ", NT(M)
1530 T = T + NT(M)
1540 GOTO 1800
1599 :
1699 REM look for old data
1700 IF TYPE(M) = 0 THEN PRINT "NO DATA; NEED INPUT", CHR$(7): GOTO 1000
1710 IF TYPE(M) = 1 GOTO 1370
1720 IF TYPE(M) = 2 THEN PRINT TAB(15) "AMP";: GOSUB 3000: GOTO 1800
1730 IF TYPE(M) = 3 THEN PRINT TAB(15) "MIX";: GOSUB 3000: GOTO 1800
1740 IF TYPE(M) = 4 THEN PRINT TAB(15) "CAB";: GOSUB 3100: GOTO 1800
1750 IF TYPE(M) = 5 THEN PRINT TAB(15) "ATT";: GOSUB 3100: GOTO 1800
1760 IF TYPE(M) = 6 THEN PRINT TAB(15) "ANT";: GOTO 1530
1770 IF TYPE(M) = 7 THEN PRINT TAB(15) "END": GOTO 200
1799 :
1800 GOSUB 2500
1840 IF TYPE(M) = 6 OR TYPE(M) = 7 GOTO 200: REM end of calculations
1850 GOTO 300: REM go back for more input
1899 :
1999 REM 3rd order intermod analysis
2000 PRINT: PRINT "THIRD ORDER INTERMODULATION ANALYSIS"
2010 PRINT: PRINT "Inputs": PRINT "3rd order input intercepts for 'rest of system' and for AMP or MIX stages."
2020 PRINT "Enter values in dBm, or hit [RETURN] to input a high value (100dBm)."
2030 PRINT: PRINT "Outputs": PRINT "For each stage: 3rd order input intercept referred to system input."
2040 PRINT "For whole system: input intercept (dBm), noise floor (dBm), dynamic range (dB).": PRINT
2050 GT = G: T = 0: G = 1: REM save old total gain; re-initialize
2060 IP = 1E+10: REM IP is running-total system input intercept (mW); initializeat a high value
2070 COH = 1: REM non-coherent option is seldom used, and can be REM'd out.
2080 REM INPUT "Input N for non-coherent addition of ip's, [RETURN] for coherent addition: ", T$: IF T$ = "N" THEN COH = 0
2090 GOSUB 2400
2100 M = 1
2110 IF TYPE(M) = 1 THEN GOSUB 3000: PRINT "Rest of system";: GOTO 2170
2120 IF TYPE(M) = 2 THEN GOSUB 3000: PRINT "Stage";M;"(AMP)";: GOTO 2170
2130 IF TYPE(M) = 3 THEN GOSUB 3000: PRINT "Stage";M;"(MIX)";: GOTO 2170
2140 IF TYPE(M) = 4 THEN GOSUB 3100: PRINT "Stage";M;"(CAB)";: IM = 1E+10: GOTO 2230
2150 IF TYPE(M) = 5 THEN GOSUB 3100: PRINT "Stage";M;"(ATT)";: IM = 1E+10: GOTO 2230
2160 IF TYPE(M) >=  6 THEN GOTO 2250
2170 INPUT" ip3 (dBm): ", T$
2179 REM  IM is stage input intercept. If high, leave alone; else refer to system input.
2180 IF T$ = "" THEN IM = 1E+10: GOTO 2200: REM default high value
2190 IM = FNA(VAL(T$)) * G/GT: REM stage intercept, referred to system input
2200 IF M = 1 THEN IP = IM: GOTO 2230
2210 IF COH = 1 THEN IP = 1/(1/IP + 1/IM): REM new running-total system input intercept
2220 IF COH = 0 THEN IP = 1/SQR(1/(IP * IP) + 1/(IM * IM)) 
2230 GOSUB 2500
2240 M = M + 1: GOTO 2110 
2250 PRINT: PRINT "Whole receiver:";: IP = FNB(IP): PRINT; TAB(66); FNC(IP)
2260 MDS = T * 1.38E-23 * 2500: MDS = FNB(MDS) + 30: REM dBm
2270 SFDR = 2 * (IP - MDS)/3
2280 PRINT "Noise floor (2.5kHz) = "; FNC(MDS); "dBm": PRINT "Dynamic range = "; FNC(SFDR); "dB"
2290 ID = 0: GOTO 200: REM clear IP flag
2298 :
2299 REM Info subroutine
2300 PRINT"The following types of stages are recognized by their first 3 CAPITAL letters : "
2310 PRINT"AMPlifier or MIXer, CABle or ATTenuator, ANTenna (and also END)"
2320 PRINT: RETURN
2398 :
2399 REM Heading subroutine
2400 PRINT: PRINT "STAGE PARAMETERS"; TAB(45); "SYSTEM RESULTS"
2410 PRINT TAB(30); "T(K)"; TAB(42); "NF(dB)"; TAB(54); "G(dB)";
2420 IF ID <> 0 THEN PRINT TAB(66); "IPi3(dBm)": RETURN
2430 PRINT: RETURN
2498 :
2499 REM Output subroutine
2500 F1 = FNB(T/290 + 1)
2510 G1 = FNB(G)
2520 PRINT TAB(30); FNC(T); TAB(42); : IF TYPE(M) = 6 THEN PRINT: RETURN
2530 PRINT; FND(F1); TAB(54); FNC(G1);
2540 IF ID = 0 OR TYPE(M) > 6 THEN PRINT: RETURN
2550 IM = FNB(IM): PRINT; TAB(66); FNC(IM): RETURN
2998 :
2999 REM  AMP/MIX calc
3000 T = NT(M) + T/GAIN(M)
3010 G = G * GAIN(M)
3020 RETURN
3098 :
3099 REM  CABle/ATTen calc
3100 T = 290 * (1/GAIN(M) - 1) + T/GAIN(M)
3110 G = G * GAIN(M)
3120 RETURN
